"use strict";
const debug = 0;

// ボタン一時無効化
async function disableButton(aid) {
  console.log("disableButton:", aid);
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);

  const existingData = await getStorage(settingId, {
    settingName: "設定1",  // 設定名の初期値を指定
    buttonCountB: "",
    buttonCountL: "",
    buttonCountR: "",
    waitTime: "",
    recoveryOption: "",
    recoveryUrl: "",
    buttonSettingsB: "",
    buttonSettingsL: "",
    buttonSettingsR: "",
    buttonSettingsA: "",
    buttonSettingsO: "",
  });

  const buttonSettingsL = await getButtonSettings("L", settingId);
  for (const buttonSetting of buttonSettingsL) {
    if (buttonSetting.url.includes(aid)) {
      buttonSetting.disabledStartTime = Date.now();
    }
  }
  const buttonSettingsR = await getButtonSettings("R", settingId);
  for (const buttonSetting of buttonSettingsR) {
    if (buttonSetting.url.includes(aid)) {
      buttonSetting.disabledStartTime = Date.now();
    }
  }
  const buttonSettingsA = await getButtonSettings("A", settingId);
  for (const buttonSetting of buttonSettingsA) {
    if (buttonSetting.url.includes(aid)) {
      buttonSetting.disabledStartTime = Date.now();
    }
  }

  // データをマージして保存
  const newData = { ...existingData, buttonSettingsL, buttonSettingsR, buttonSettingsA };
  await setStorage(settingId, newData);
}


// 編成HTMLからボタンのテキストとURLを抽出しストレージに保存
async function getButtonsData() {
  // ボタンのデータを格納する配列
  var formData = [];

  // 特定の条件に一致するimg要素を取得
  var imgElements = document.querySelectorAll('img[src*="2Fability%2Ffull"]');
  console.log("img", imgElements);
  imgElements.forEach(function (imgElement) {
    var src = imgElement.getAttribute('src');
    var match_aid = src.match(/2F(\d+)\.jpg/);
    var aid;
    if (match_aid) {
      aid = match_aid[1];
      //console.log('Numeric Part:', aid);
    }
    var aname = imgElement.getAttribute('alt');
    formData.push({ aid: aid, aname: aname });
  });

  // ローカルストレージに保存
  await new Promise((resolve) => {
    chrome.storage.local.set({ 'formData': formData }, function () {
      console.log('Data saved to local storage:', formData);
      resolve();
    });
  });
  await bsleep(500);
}


async function getAbilityFromEquip() {
  // 軍師P1
  const url1 = "https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fuser%2Fequip_list_sp.aspx%3Fecat%3D1%26did%3D1%26crp%3D1%26rnd%3D662221&guid=ON";
  // 軍師P2
  const url2 = "https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fuser%2Fequip_list_sp.aspx%3Fecat%3D1%26did%3D1%26crp%3D2%26rnd%3D345085&guid=ON";

  if (window.location.href.includes("user_equip_ability_list.aspx")) {
    // 所持アビ
    const formData = [];
    const abilityElements = document.querySelectorAll('.ability-list__button.equiped');

    abilityElements.forEach(element => {
      const url = element.getAttribute('data-abilityUrl');
      const match = url.match(/aid%3D(\d+)/);
      const aid = match ? match[1] : null;

      const text = element.textContent.trim();
      const match2 = text.match(/([^\d]+)/);
      const aname = match2 ? match2[1] : null;

      if (aid && aname) {
        formData.push({ aid: aid, aname: aname });
      }
    });

    console.log(formData);

    await new Promise((resolve) => {
      chrome.storage.local.set({ 'formData': formData }, function () {
        console.log('Data saved to local storage:', formData);
        resolve();
      });
    });

    await window.location.assign(url1);
  } else if (window.location.href.includes(url1) || window.location.href.includes(url2)) {
    // 軍師編成
    const ogiData = [];
    const bodys = document.querySelectorAll("div[id^='body_rpCharactors_charactorDetail_']");
    console.log("bodys:", bodys);
    const elementsCard = document.querySelectorAll(".equip-card");
    console.log("elementsCard:", elementsCard);

    let i = 0;
    await elementsCard.forEach(element => {
      const img = element.querySelector("li img[src*='charactor']");
      let eid;
      if (img) {
        const src = img.getAttribute('src');
        const match = src.match(/%2F(\d+).jpg/);
        eid = match ? match[1] : null;

        const ogi = bodys[i].querySelector("li.equip-icon-ougi.btn.equip-select");
        if (ogi) {
          // 魏呉蜀群判定
          const ggsg = {
            gi: bodys[i].classList.contains('equipbg-gi') ? parseInt("1000", 2) : null,
            gun: bodys[i].classList.contains('equipbg-gun') ? parseInt("0001", 2) : null,
            go: bodys[i].classList.contains('equipbg-go') ? parseInt("0100", 2) : null,
            shoku: bodys[i].classList.contains('equipbg-shoku') ? parseInt("0010", 2) : null,
          };
          const ggsgValue = Object.values(ggsg).find(value => value !== null);
          console.log("ggsgValue:", ggsgValue);

          const abilityLink = ogi.querySelector(".ability-link");
          if (abilityLink) {
            const dataAbilityUrl = abilityLink.getAttribute("data-abilityUrl");
            const matchAid = dataAbilityUrl.match(/aid%3D(\d+)/);
            const aid = matchAid ? matchAid[1] : null;
            console.log(`aid[${i}]:`, aid);
            console.log(`eid[${i}]:`, eid);

            const abilityNameElement = abilityLink.querySelector(".ability-name");
            let abilityName = abilityNameElement ? abilityNameElement.textContent.trim() : null;
            abilityName = abilityName.replace(/\s+.+/, '');
            console.log(`奥義 abilityName[${i}]:`, abilityName);
            ogiData.push({ aid: aid, eid: eid, aname: abilityName, ggsg: ggsgValue });
          }
        }
      }
      i++;
    });


    if (window.location.href.includes(url1)) {
      console.log("軍師1end");
      chrome.storage.local.set({ 'ogiData': ogiData }, function () {
        console.log('Data saved to local storage:', ogiData);
      });
      await window.location.assign(url2);
    } else {
      console.log("軍師2end");
      // 保存前に既存のデータを取得して追加
      await chrome.storage.local.get('ogiData', function (result) {
        const existingData = result.ogiData || [];
        const newData = existingData.concat(ogiData);

        chrome.storage.local.set({ 'ogiData': newData }, function () {
          console.log('Data saved to local storage:', newData);
        });
      });
      await bsleep(500);
      chrome.runtime.sendMessage({ type: 'closeTab' });
    }
  } else {
    console.log("異常ルート");
    chrome.runtime.sendMessage({ type: 'closeTab' });
  }
}


async function getFormation() {
  const cardData = [];
  const url = window.location.href;

  // ecat%3D1の部分を取り出す
  const ecatMatch = url.match(/ecat%3D(\d+)/);
  const ecat = ecatMatch ? parseInt(ecatMatch[1], 10) : null;
  console.log("ecat:", ecat);

  // crp%3D1の部分を取り出す
  const crpMatch = url.match(/crp%3D(\d+)/);
  const crp = crpMatch ? parseInt(crpMatch[1], 10) : null;
  console.log("crp:", crp);

  const ctype = ecat ? "軍師" : "武将";

  if ((ecat == 0 || ecat == 1) && crp) {
    // カード枠
    const bodys = document.querySelectorAll("div[id^='body_rpCharactors_charactorDetail_']");
    let i = 0;
    for (const body of bodys) {
      const cinfo = await getCardInfo(ctype, i + 1 + (crp - 1) * 10, body);
      cardData.push(cinfo);
      i++;
    };

    let ecatNext = ecat;
    let crpNext = crp + 1;
    if (ecat == 0 && crp == 4) {
      // 4ページ目の場合は軍師Pへ
      ecatNext = 1;
      crpNext = 1;
    }

    const urlNext = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fuser%2Fequip_list_sp.aspx%3Fecat%3D${ecatNext}%26did%3D1%26crp%3D${crpNext}%26rnd%3D432843&guid=ON`;

    if (ecat == 0 && crp == 1) {
      // 設定名取得
      const fname = getFormationName();
      console.log("Formation Name:", fname);
      cardData[0].fname = fname;

      // カード情報をストレージに新規保存
      await chrome.storage.local.set({ 'cardData': cardData }, function () {
        console.log('Data saved to local storage:', cardData);
      });
      await window.location.assign(urlNext);
    }
    else {
      // 2ページ目以降 カード情報を追加保存
      await chrome.storage.local.get('cardData', function (result) {
        const existingData = result.cardData || [];
        console.log('Data before:', existingData);
        const newData = existingData.concat(cardData);
        bsleep(100);
        chrome.storage.local.set({ 'cardData': newData }, function () {
          console.log('Data saved to local storage:', newData);
        });
      });

      if (ecat == 1 && crpNext > 2) {
        // 終了
        await bsleep(300);
        await chrome.runtime.sendMessage({ type: 'closeTab' });
      }
      else {
        await window.location.assign(urlNext);
      }
    }
  }
  else {
    console.error("想定外URL:", url);
  }
}

function getFormationName() {
  const powerBox = document.querySelector('.power-box');
  if (powerBox) {
    const currentFormation = powerBox.querySelector('.ac-open');
    if (currentFormation) {
      const formationText = currentFormation.innerText;
      const matchResult = formationText.match(/\[([^[\]]+)\]/);
      if (matchResult) {
        return matchResult[1];
      } else {
        console.log("Formation not found.");
      }
    } else {
      console.log("Current formation box not found.");
    }
  } else {
    console.log("Power box not found.");
  }

  // デフォルトの値（エラー時に返す値）を指定するか、もしくはエラー処理を行うかに応じて調整してください
  return null;
}


// カード情報
async function getCardInfo(ctype, no, body) {
  // BASEカード
  const eid = getBaseCardEid(body);
  const name = getBaseCardName(body);
  const rare = getCardRare(body);
  const { lv, cost, bs } = getBaseCardLvCostBs(body);
  const abilities = getAbilities(body);
  console.log(`▶${name} ${rare} Lv: ${lv}, cost: ${cost}, bs: ${bs}, ${abilities}`);

  const supportCards = [];
  // 援護カード <td class="child-img">
  let i = 0;
  const table1 = body.querySelector('table.child-list');
  if (table1) {
    // table 内のすべての tr 要素を取得
    const trElements = table1.querySelectorAll('tr') || '';
    //console.log("trElements:", trElements);
    for (const element of trElements) {
      //console.log(`[${no}]援護:`, i);
      const supportCard = await getChildList(element, '.child-list');
      if (supportCard) {
        supportCards.push(supportCard);
      }
      i++;
    }
  }

  // 加勢カード
  const table2 = body.querySelector('table.child-list-support');
  if (table2) {
    // table 内のすべての tr 要素を取得
    const trElements = table2.querySelectorAll('tr') || '';

    for (let i = 0; i < trElements.length; i++) {
      const trElement = trElements[i];
      console.log(` [${no}] 加勢 i:`, i);
      var supportCard = '';
      var equipElement = '';
      if (i + 1 < trElements.length) {
        equipElement = trElements[i + 1].querySelector('ul.equip-ability');
        // 次のtrがあってアビが含まれる場合
        if (equipElement) {
          supportCard = await getChildList(trElement, '.child-list-support', trElements[i + 1]);
          i++;
        }
      }
      if (!supportCard) {
        supportCard = await getChildList(trElement, '.child-list-support', "");
      }
      if (supportCard) {
        // 加勢枠が編成済みの場合
        await supportCards.push(supportCard);
      }
    }
  }

  const info = {
    ctype: ctype,
    no: no,
    name: name,
    eid: eid,
    rare: rare,
    Lv: parseInt(lv),
    cost: parseInt(cost),
    bs: parseInt(bs),
    abilities: abilities,
    supportCards: supportCards
  };

  return info;
}


// 援護/加勢
async function getChildList(element, klass, element2) {
  var info = {};
  const nameElements = element.querySelectorAll('a[href*="charactor_detail"]');
  let secondNameElement;

  // 2行目の要素を取得
  if (nameElements.length >= 2) {
    secondNameElement = nameElements[1];
  }

  const nameWithRare = secondNameElement ? secondNameElement.textContent.trim() : '';
  const name = nameWithRare.replace(/\([^)]*\)/g, '').trim();
  if (!name) {
    return;
  }
  //console.log("name:", name);
  const rare = getCardRare(secondNameElement);
  console.log("element:", element);
  const eid = getBaseCardEid(element);
  info.name = name;
  info.rare = rare;
  info.eid = eid;

  if (klass == '.child-list') {
    info.type = "援護";
    console.log(` [援護] ${name}, ${rare}`);
  }
  else {
    info.type = "加勢";
    // アビリスト 	<li class="equip-icon-front btn equip-select">
    let abilities = '';
    if (element2) {
      abilities = getAbilities(element2);
      if (abilities) {
        info.abilities = abilities;
      }
    }
    console.log(` [加勢] ${name}, ${rare} ${abilities}`);
  }
  return info;
}


function getAbilities(body) {
  const equipElement = body.querySelector('ul.equip-ability');
  const abilityElements = equipElement.querySelectorAll('.ability-name');
  const abilities = Array.from(abilityElements).map(element => {
    // アビリティ名を取得する
    const abilityName = Array.from(element.childNodes).filter(node => node.nodeName === '#text').map(node => node.textContent.trim()).join('');
    // 継承アイコン
    const hasIcon = element.querySelector('.icon-inherit--small') !== null;
    const enhancedAbility = hasIcon ? `${abilityName}*` : abilityName;
    return enhancedAbility;
  }).join(', ');
  return abilities;
}


function getBaseCardLvCostBs(body) {
  const div = body.querySelector('div');
  const text = div.querySelector('span:nth-of-type(1)').parentNode.textContent.trim();
  const matchLv = text.match(/\d+/);
  const lv = matchLv ? matchLv[0] : null;
  const cost = div.querySelector('.cost-point').textContent;
  const matchBs = text.match(/(\d+)\/\d+/);
  const bs = matchBs ? matchBs[1] : null;
  return { lv, cost, bs };
}


function getCardRare(body) {
  const spanElement = body.querySelector('span.blink, span[style*="color:red"], span[style*="color:orange"], span[style*="color:aqua"]');
  const rare = spanElement ? spanElement.textContent.trim() : '';
  return rare;
}


function getBaseCardName(body) {
  const cardElements = body.querySelectorAll('.equip-card li');
  const nameElement = cardElements[1].querySelector('a[href*="charactor_detail"]'); // 2回目のcharactor_detail
  const nameText = nameElement ? nameElement.innerText.trim() : '';
  const matchName = nameText.match(/(.+)\(/); // )
  const name = matchName[1];
  return name;
}


function getBaseCardEid(body) {
  console.log("body:", body);
  const img = body.querySelector("img[src*='charactor']");
  console.log("img:", img);
  const src = img.getAttribute('src');
  const match = src.match(/%2F(\d+).jpg/);
  const eid = match ? match[1] : null;
  return eid;
}


// アビ合計回数取得関数
function extractTotalCount(html) {
  const pattern1 = /<span>合計回数<\/span>(\d+)/;
  const pattern2 = /<span>合計回数<\/span><span[^>]*>(\d+)<\/span>/;
  const match1 = html.match(pattern1);
  const match2 = html.match(pattern2);
  if (match1) {
    return match1[1];
  } else if (match2) {
    return match2[1];
  } else {
    return null;
  }
}


async function createMenu() {
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);

  const emptySpace = document.createElement('div');
  emptySpace.classList.add('empty-space');
  document.body.appendChild(emptySpace);

  const hideLinkButtons = await getHideLinkButtons();
  if (hideLinkButtons == true) {
    // メニューボタンのみ表示
    createMenuButtons();
  }
  else {
    // 下
    createButtonsB1(settingId);
    createMenuButtons();

    const currentUrl = window.location.href;
    //console.log("curl:", currentUrl);
    if (currentUrl.includes("mbga-sp.daisenran.jp")) {
      const menuL1 = createMenuContainerL();
      createButtons(menuL1, settingId, "L");
      const menuR1 = createMenuContainerR();
      createButtons(menuR1, settingId, "R");
    }
  }
}


// Menuボタンクリック
async function createAdvancedMenu() {
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);

  const buttonsContainer = createAdvancedLinkButtonsContainer();
  if (buttonsContainer) {
    await clearStatus();
    await clearTabState();
    // 新規に拡張メニューを表示
    createButtons(buttonsContainer, settingId, "A");
    // 既存下リンクボタン非表示
    removeBottomLinkButtons();
    // 下リンクボタンを拡張Menuに書き換え
    createAdvancedMenuButtons();
    // 奥義リンクボタン表示
    createOgiLinkButtons();
  }
  else {
    // 表示状態でMenuが押された場合、表示⇒非表示
    // toggle
    removeButtons("AdvancedMenuButtons");
    removeBottomLinkButtons();
    createButtonsB1(settingId);
  }
}


function removeBottomLinkButtons() {
  var bottomLinkButtons = document.getElementById('bottomLinkButtons');
  if (bottomLinkButtons) {
    bottomLinkButtons.parentNode.removeChild(bottomLinkButtons);
  }
  var ogiLinkButtons = document.getElementById('ogiLinkButtons');
  if (ogiLinkButtons) {
    ogiLinkButtons.parentNode.removeChild(ogiLinkButtons);
  }
}

function removeButtons(id) {
  var buttons = document.getElementById(id);
  if (buttons) {
    buttons.parentNode.removeChild(buttons);
  }
}


async function createAdvancedMenuButtons() {
  //console.log("createAdvancedMenu");
  const bottomLinkButtons = createBButtonsContainer();
  createButton("URL取得", "linkMUrl", bottomLinkButtons, "", true);
  createCheckBox("アビ使い切り", "linkMAbi", bottomLinkButtons);
  createButton("About", "linkMAbout", bottomLinkButtons, "", true);
}


// 奥義リンクボタン
async function createOgiLinkButtons() {
  const ogiLinkButtons = createOgiButtonsContainer();
  const buttonType = "O";
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);
  const buttonSettings = await getButtonSettings(buttonType, settingId);

  for (let i = 1; i <= 3; i++) {
    const linkText = i != null ? buttonSettings[i - 1]?.text : null;
    const linkAction = `link${buttonType}${i}`;
    createOgiButton(linkText, linkAction, ogiLinkButtons, buttonSettings[i - 1].ggsg);
  }
}


function hideButtons(id) {
  var buttons = document.getElementById(id);
  if (buttons) {
    buttons.style.display = 'none';
  }
}


function hideBottomLinkButtons() {
  var bottomLinkButtons = document.getElementById('bottomLinkButtons');
  if (bottomLinkButtons) {
    bottomLinkButtons.style.display = 'none';
  }
}


// 状態表示(上)
function createStatusElement() {
  return;
  var element = document.getElementById('statusTop');
  if (!element) {
    const statusElement = document.createElement("div");
    statusElement.id = "statusTop";
    document.body.appendChild(statusElement);
  }
}


// メッセージエリア(下)
function createStatusMessageElement() {
  var element = document.getElementById('statusMessage');
  if (!element) {
    const statusMessageElement = document.createElement("div");
    statusMessageElement.id = "statusMessage";
    document.body.appendChild(statusMessageElement);
  }
}


function createMenuContainerL() {
  const menu = document.createElement("aside");
  document.body.appendChild(menu);
  const shadow = menu.attachShadow({ mode: "closed" });
  const link = document.createElement("link");
  link.rel = "stylesheet";
  link.href = chrome.runtime.getURL("inject.css");
  shadow.appendChild(link);
  const nav = shadow.appendChild(document.createElement("nav"));
  nav.className = "rise_left1";
  nav.textContent = "";
  return nav;
}


function createMenuContainerR() {
  const menu = document.createElement("aside");
  document.body.appendChild(menu);
  const shadow = menu.attachShadow({ mode: "closed" });
  const link = document.createElement("link");
  link.rel = "stylesheet";
  link.href = chrome.runtime.getURL("inject.css");
  shadow.appendChild(link);
  const nav = shadow.appendChild(document.createElement("nav"));
  nav.className = "rise_right1";
  nav.textContent = "";
  return nav;
}


async function createButtons(container, settingId, buttonType, addHighlight = false) {
  const buttonSettings = await getButtonSettings(buttonType, settingId);
  const buttonCount = await getButtonCount(buttonType, settingId);

  let linkButtonsContainer;
  if (buttonType == "A") {
    linkButtonsContainer = container;
  }
  else {
    linkButtonsContainer = createLRButtonsContainer(container);
  }

  for (let i = 1; i <= buttonCount; i++) {
    const linkText = i != null ? buttonSettings[i - 1]?.text : null;
    const linkAction = `link${buttonType}${i}`;
    const disabledStartTime = buttonSettings[i - 1]?.disabledStartTime;
    let addDisabled = false;
    if (disabledStartTime) {
      const elapsedTime = (Date.now() - disabledStartTime) / 1000 / 60; // 分単位
      if (elapsedTime < 30) {
        addDisabled = true;
      } else {
        buttonSettings[i - 1].disabledStartTime = null;
      }
    }
    //console.log(`${buttonType}: ${linkText} = ${addDisabled}`);
    const property = buttonSettings[i - 1]?.property;
    //console.log("property:", property);
    createButton(linkText, linkAction, linkButtonsContainer, property, addHighlight, addDisabled);
  }
}


async function createButtonsB1() {
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);

  const buttonCount = await getButtonCount("B", settingId);
  const buttonSettings = await getButtonSettings("B", settingId);
  const bottomLinkButtons = createBButtonsContainer();

  for (let i = 1; i <= buttonCount; i++) {
    const linkText = i != null ? buttonSettings[i - 1]?.text : null;
    const linkAction = `linkB${i}`;

    const disabledStartTime = buttonSettings[i - 1]?.disabledStartTime;
    let addDisabled = false;
    if (disabledStartTime) {
      const elapsedTime = (Date.now() - disabledStartTime) / 1000 / 60; // 分単位
      if (elapsedTime < 30) {
        addDisabled = true;
      } else {
        buttonSettings[i - 1].disabledStartTime = null;
      }
    }
    // 引数 addDisabled を設定
    const property = "";
    createButton(linkText, linkAction, bottomLinkButtons, property, true, addDisabled);
  }
}


// メニューボタン
async function createMenuButtons() {
  const tabId = await getTabId();
  const settingId = await getSettingId(tabId);
  const buttonCount = 5;
  const bottomLinkButtons = createMenuButtonsContainer();

  const linkText1 = "◀";
  const linkAction1 = "linkMPrevTab";
  // 引数 addHighlight を false に設定
  createButton(linkText1, linkAction1, bottomLinkButtons, "", false);

  const settingName = await getsettingName(settingId);
  const linkText3 = `[${settingId}]  ${settingName}`;
  const linkAction3 = "linkMOption";
  createButton(linkText3, linkAction3, bottomLinkButtons, "", true);

  const hideLinkButtons = await getHideLinkButtons();
  const linkText2 = "表示ON/OFF";
  const linkAction2 = "linkMDispButtons";
  if (hideLinkButtons) {
    //　非表示時
    createButton(linkText2, linkAction2, bottomLinkButtons, "", false, true);
  }
  else {
    //　表示時
    createButton(linkText2, linkAction2, bottomLinkButtons, "", false);
  }

  const linkText4 = "Menu";
  const linkAction4 = "linkMenu";
  createButton(linkText4, linkAction4, bottomLinkButtons, "", false);

  const linkText5 = "▶";
  const linkAction5 = "linkMNextTab";
  createButton(linkText5, linkAction5, bottomLinkButtons, "", false);
}


// 拡張メニューボタン
function createAdvancedLinkButtonsContainer() {
  let container = document.getElementById("AdvancedMenuButtons");
  if (!container) {
    const body = document.body || document.documentElement;
    if (!body) {
      console.error("Document body is null or undefined.");
      return null;
    }

    container = document.createElement("div");
    container.id = "AdvancedMenuButtons";
    container.classList.add("AdvancedMenuButtons");
    body.appendChild(container);
    return container;
  }
}


// 下メニューボタン
function createMenuButtonsContainer() {
  let bottomContainer = document.getElementById("bottomMenuButtons");
  if (!bottomContainer) {
    const body = document.body || document.documentElement;
    if (!body) {
      console.error("Document body is null or undefined.");
      return null;
    }

    bottomContainer = document.createElement("div");
    bottomContainer.id = "bottomMenuButtons";
    bottomContainer.classList.add("bottomMenuButtons");
    body.appendChild(bottomContainer);
  }
  return bottomContainer;
}


// 下リンクボタン
function createBButtonsContainer() {
  let bottomContainer = document.getElementById("bottomLinkButtons");
  if (!bottomContainer) {
    const body = document.body || document.documentElement;
    if (!body) {
      console.error("Document body is null or undefined.");
      return null;
    }

    bottomContainer = document.createElement("div");
    bottomContainer.id = "bottomLinkButtons";
    bottomContainer.classList.add("bottomLinkButtons");
    body.appendChild(bottomContainer);

    // ステータスメッセージ用の要素を追加
    var element = document.getElementById('statusMessage');
    if (!element) {
      const statusMessageElement = document.createElement("div");
      statusMessageElement.id = "statusMessage";
      body.appendChild(statusMessageElement);
    }
  }
  return bottomContainer;
}


// 奥義ボタン枠
function createOgiButtonsContainer() {
  let ogiContainer = document.getElementById("ogiLinkButtons");
  if (!ogiContainer) {
    const body = document.body || document.documentElement;
    if (!body) {
      console.error("Document body is null or undefined.");
      return null;
    }
    ogiContainer = document.createElement("div");
    ogiContainer.id = "ogiLinkButtons";
    ogiContainer.classList.add("ogiLinkButtons");
    body.appendChild(ogiContainer);

    // ステータスメッセージ用の要素を追加
    var element = document.getElementById('statusMessage');
    if (!element) {
      const statusMessageElement = document.createElement("div");
      statusMessageElement.id = "statusMessage";
      body.appendChild(statusMessageElement);
    }
  }
  return ogiContainer;
}


function createLRButtonsContainer(container) {
  const leftContainer = document.createElement("div");
  leftContainer.id = "LRLinkButtons";
  leftContainer.classList.add("LRLinkButtons");
  container.appendChild(leftContainer);
  return leftContainer;
}


// ボタン生成関数
async function createButton(text, action, container, property, addHighlight = false, addDisabled = false) {
  //console.log("action:", action);
  const button = createElement("div", "customButton", { "data-action": action }, text);
  container.appendChild(button);

  // 必要に応じて highlight クラスを追加
  if (addHighlight) {
    button.classList.add('highlight');
  }

  // 必要に応じて disabled クラスを追加
  if (addDisabled) {
    button.classList.add('disabled');
  }
  else if (property) {
    const bit = await decimalToBinaryBits(parseInt(property));
    //console.log(`${text} bit:`, bit);

    if (bit.b6) { // 滅
      button.classList.add('button-back-purple');
      if (bit.b5) {
        button.classList.add('arrow_up2');
      }
      else if (bit.b1) { //応援 低下
        if (bit.b5) {
          button.classList.add('arrow_down2');
        }
        else {
          button.classList.add('arrow_down');
        }
      }
    }
    else if (bit.b3) { //計略、弓
      button.classList.add('button-stratagem_bow');
      if (bit.b5) {
        button.classList.add('arrow_up2');
      }
    }
    else {
      if (bit.b1) { //応援 低下
        if (bit.b5) {
          button.classList.add('arrow_down2');
        }
        else {
          button.classList.add('arrow_down');
        }
      }
      else if (bit.b2) { //応援 上昇
        // 上げ
        if (action) {
          if (bit.b5) {
            button.classList.add('arrow_up2');
          }
          else {
            button.classList.add('arrow_up');
          }
        }
      }
      else{
        // 前衛?
        if (bit.b5) {
          button.classList.add('arrow_up2');
        }
      }
    }

    if (bit.b7) { // 筆頭軍師　太字
      button.classList.add('first-strategist');
    }
  }

  // 種別判定
  button.addEventListener('click', handleSelection);
  return button;
}


// ボタン生成関数 奥義用
function createOgiButton(text, action, container, ggsg) {
  //console.log("createOgiButton ggsg:", ggsg);
  const button = createElement("div", "customButton", { "data-action": action }, text);
  container.appendChild(button);

  if (ggsg) {
    button.classList.add(getGGSG(ggsg));
  }

  // 必要に応じて disabled クラスを追加
  const addDisabled = false;
  if (addDisabled) {
    button.classList.add('disabled');
  }

  // 種別判定
  button.addEventListener('click', handleSelection);
  return button;
}


async function decimalToBinaryBits(num) {
  // 2進数に変換
  //console.log("input num:",num);
  const binaryStr = await num.toString(2);
  //console.log("binaryStr:",binaryStr);

  // 8桁になるまで0を追加
  const paddedStr = binaryStr.padStart(8, "0");
  //console.log("padd:",paddedStr);

  // オブジェクトに格納
  const bit = {};
  for (let i = 0; i < paddedStr.length; i++) {
    bit[`b${8 - i}`] = parseInt(paddedStr[i]);
  }

  return bit;
}


function createCheckBox(text, action, container) {
  // チェックボックス要素を作成
  const checkbox = createElement("input", "customCheckbox", { type: "checkbox", "data-action": action });
  container.appendChild(checkbox);
  checkbox.classList.add('toggle_input');

  // テキスト表示用のラベル要素を作成
  const label = createElement("label", "toggle_label", { "data-action": action }, text);
  container.appendChild(label);
  label.innerHTML = text.replace(/\s/g, '<br>');

  // ローカルストレージから値を取得して初期値として設定
  getUseUpAbility().then((useUp) => {
    checkbox.checked = useUp;
  });

  // クリック時のイベントハンドラを追加
  checkbox.addEventListener('click', function (event) {
    handleCheckboxToggle(checkbox, event);
  });

  return checkbox;
}


// チェックボックスの状態をトグルするイベントハンドラ
async function handleCheckboxToggle(checkbox, event) {
  const useUp = checkbox.checked;
  console.log("handleCheckboxToggle", useUp);
  // ローカルストレージに保存
  await setUseUpAbility(useUp);
}


function createElement(tag, klass, attr, text) {
  let n = document.createElement(tag);
  n.setAttribute("role", "button");
  if (klass) n.className = klass;
  if (attr) for (let prop in attr) n.setAttribute(prop, attr[prop]);
  if (text) n.textContent = text;
  return n;
}


function getDefaultButtonTexts(buttonCount) {
  const defaultButtonTexts = [];
  const totalButtons = buttonCount || 15;
  for (let i = 1; i <= totalButtons; i++) {
    defaultButtonTexts.push(`リンク${i}`);
  }
  return defaultButtonTexts;
}


// chrome.storage.localからbuttonSizeを取得する関数
async function getButtonSizeFromStorage(settingId) {
  return new Promise((resolve) => {
    chrome.storage.sync.get({ [settingId]: { buttonSize: "medium" } }, data => {
      const selectedValue = data[settingId].buttonSize;
      console.log("selectedValue:", selectedValue);

      // デフォルトのボタンサイズを設定
      let size;
      switch (selectedValue) {
        case 'small':
          size = { width: '80px', height: '30px', fontSize: '14px' };
          break;
        case 'medium':
          size = { width: '100px', height: '40px', fontSize: '16px' };
          break;
        case 'large':
          size = { width: '120px', height: '50px', fontSize: '18px' };
          break;
        default:
          size = { width: '100px', height: '40px', fontSize: '16px' };
      }

      resolve(size);
    });
  });
}


// CSS用
function getGGSG(ggsg) {
  //console.log("ggsg:", ggsg);
  if (ggsg == 8) {
    return "ggsg-gi";
  }
  else if (ggsg == 4) {
    return "ggsg-go";
  }
  else if (ggsg == 2) {
    return "ggsg-shoku";
  }
  else if (ggsg == 1) {
    return "ggsg-gun";
  }
  return;
}