const BASE_URL = "http://rise.3594.pgw.jp";

function displayMessage(message, success) {
    const statusMessageElement = document.getElementById("statusMessageForOption");
    statusMessageElement.textContent = message;
    statusMessageElement.style.color = success ? "green" : "red";
    setTimeout(() => {
        statusMessageElement.textContent = "";
    }, 3000);
}


// CSS用
function getGGSG(ggsg) {
    if (ggsg.value == 8) {
        return "ggsg-gi";
    }
    else if (ggsg.value == 4) {
        return "ggsg-go";
    }
    else if (ggsg.value == 2) {
        return "ggsg-shoku";
    }
    else if (ggsg.value == 1) {
        return "ggsg-gun";
    }
    return;
}


async function bsleep(waitMsec) {
    var startMsec = new Date();
    while (new Date() - startMsec < waitMsec) {
        await delay(1);
    }
}


async function delay(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}


// BOM つきの UTF-8 ファイル生成
function createBOM_UTF8(str) {
    const uint8Array = new TextEncoder().encode('\uFEFF' + str); // '\uFEFF' は BOM
    return new Blob([uint8Array], { type: 'text/csv' });
}


// ----------------------------------------------------------------------------------------
// ストレージ読み書き

async function getProfile() {
    return await new Promise((resolve) => {
        chrome.storage.local.get('Profile', function (result) {
            const storedProfile = result['Profile'];
            console.log('Data retrieved from local storage:', storedProfile);
            resolve(storedProfile);
        });
    });
}
